<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfdecimal' => '\\ArrayType\\ArrayOfdecimal',
            'ClsVoucher' => '\\StructType\\ClsVoucher',
            'ClsCredential' => '\\StructType\\ClsCredential',
            'ClsInsertVoucherResp' => '\\StructType\\ClsInsertVoucherResp',
            'ArrayOfClsInsertVoucherResp' => '\\ArrayType\\ArrayOfClsInsertVoucherResp',
            'ClsGetShipmentNumberResp' => '\\StructType\\ClsGetShipmentNumberResp',
            'ClsGetVoucherResp' => '\\StructType\\ClsGetVoucherResp',
            'ClsVoucherTracking' => '\\StructType\\ClsVoucherTracking',
            'ArrayOfClsVoucherCheckpoint' => '\\ArrayType\\ArrayOfClsVoucherCheckpoint',
            'ClsVoucherCheckpoint' => '\\StructType\\ClsVoucherCheckpoint',
            'ClsGetVoucherTrackingResp' => '\\StructType\\ClsGetVoucherTrackingResp',
            'ClsGetVoucherTracking_StationResp' => '\\StructType\\ClsGetVoucherTracking_StationResp',
            'ClsVoucherTracking_Station' => '\\StructType\\ClsVoucherTracking_Station',
            'ArrayOfClsVoucherCheckpoint_Station' => '\\ArrayType\\ArrayOfClsVoucherCheckpoint_Station',
            'ClsVoucherCheckpoint_Station' => '\\StructType\\ClsVoucherCheckpoint_Station',
            'ClsStation' => '\\StructType\\ClsStation',
            'ClsVouchersTrackingTimePeriodResp' => '\\StructType\\ClsVouchersTrackingTimePeriodResp',
            'ArrayOfClsGetVoucherTracking_StationResp' => '\\ArrayType\\ArrayOfClsGetVoucherTracking_StationResp',
            'ClsVouchersTrackingTimePeriodResp2' => '\\StructType\\ClsVouchersTrackingTimePeriodResp2',
            'ArrayOfClsGetVoucherTracking_StationResp2' => '\\ArrayType\\ArrayOfClsGetVoucherTracking_StationResp2',
            'ClsGetVoucherTracking_StationResp2' => '\\StructType\\ClsGetVoucherTracking_StationResp2',
            'ClsVoucherTracking_Station2' => '\\StructType\\ClsVoucherTracking_Station2',
            'ArrayOfClsVoucherCheckpoint_Station2' => '\\ArrayType\\ArrayOfClsVoucherCheckpoint_Station2',
            'ClsVoucherCheckpoint_Station2' => '\\StructType\\ClsVoucherCheckpoint_Station2',
            'ClsVouchersTracking_By_ItemIDResp' => '\\StructType\\ClsVouchersTracking_By_ItemIDResp',
            'ClsCheckSpecialsResp' => '\\StructType\\ClsCheckSpecialsResp',
            'ClsCancelVoucherResp' => '\\StructType\\ClsCancelVoucherResp',
            'ClsGetVouchersXpsResp' => '\\StructType\\ClsGetVouchersXpsResp',
            'ClsGetVouchersXps_UrlResp' => '\\StructType\\ClsGetVouchersXps_UrlResp',
            'ClsGetVouchersPdfResp' => '\\StructType\\ClsGetVouchersPdfResp',
            'ClsGetVouchersPdf_UrlResp' => '\\StructType\\ClsGetVouchersPdf_UrlResp',
            'ClsGetVoucherPODResp' => '\\StructType\\ClsGetVoucherPODResp',
            'ClsGetVoucherPDFResp' => '\\StructType\\ClsGetVoucherPDFResp',
            'DoWork' => '\\StructType\\DoWork',
            'DoWorkResponse' => '\\StructType\\DoWorkResponse',
            'InsertVoucher' => '\\StructType\\InsertVoucher',
            'InsertVoucherResponse' => '\\StructType\\InsertVoucherResponse',
            'GetShipmentNumber' => '\\StructType\\GetShipmentNumber',
            'GetShipmentNumberResponse' => '\\StructType\\GetShipmentNumberResponse',
            'GetVoucher' => '\\StructType\\GetVoucher',
            'GetVoucherResponse' => '\\StructType\\GetVoucherResponse',
            'GetVoucherMargins' => '\\StructType\\GetVoucherMargins',
            'GetVoucherMarginsResponse' => '\\StructType\\GetVoucherMarginsResponse',
            'GetVoucherTracking' => '\\StructType\\GetVoucherTracking',
            'GetVoucherTrackingResponse' => '\\StructType\\GetVoucherTrackingResponse',
            'GetVoucherTrackingLanguage' => '\\StructType\\GetVoucherTrackingLanguage',
            'GetVoucherTrackingLanguageResponse' => '\\StructType\\GetVoucherTrackingLanguageResponse',
            'GetVoucherTracking_Station' => '\\StructType\\GetVoucherTracking_Station',
            'GetVoucherTracking_StationResponse' => '\\StructType\\GetVoucherTracking_StationResponse',
            'GetVouchersTracking_By_TimePeriod' => '\\StructType\\GetVouchersTracking_By_TimePeriod',
            'GetVouchersTracking_By_TimePeriodResponse' => '\\StructType\\GetVouchersTracking_By_TimePeriodResponse',
            'GetVouchersTracking_By_TimePeriod2' => '\\StructType\\GetVouchersTracking_By_TimePeriod2',
            'GetVouchersTracking_By_TimePeriod2Response' => '\\StructType\\GetVouchersTracking_By_TimePeriod2Response',
            'GetVouchersTracking_By_ItemID' => '\\StructType\\GetVouchersTracking_By_ItemID',
            'GetVouchersTracking_By_ItemIDResponse' => '\\StructType\\GetVouchersTracking_By_ItemIDResponse',
            'GetVoucherTracking_By_ItemID' => '\\StructType\\GetVoucherTracking_By_ItemID',
            'GetVoucherTracking_By_ItemIDResponse' => '\\StructType\\GetVoucherTracking_By_ItemIDResponse',
            'CheckSpecials' => '\\StructType\\CheckSpecials',
            'CheckSpecialsResponse' => '\\StructType\\CheckSpecialsResponse',
            'CancelVoucher' => '\\StructType\\CancelVoucher',
            'CancelVoucherResponse' => '\\StructType\\CancelVoucherResponse',
            'GetVouchersXps' => '\\StructType\\GetVouchersXps',
            'GetVouchersXpsResponse' => '\\StructType\\GetVouchersXpsResponse',
            'GetVouchersXps_Url' => '\\StructType\\GetVouchersXps_Url',
            'GetVouchersXps_UrlResponse' => '\\StructType\\GetVouchersXps_UrlResponse',
            'GetVouchersPdf' => '\\StructType\\GetVouchersPdf',
            'GetVouchersPdfResponse' => '\\StructType\\GetVouchersPdfResponse',
            'GetVouchersPdf_Url' => '\\StructType\\GetVouchersPdf_Url',
            'GetVouchersPdf_UrlResponse' => '\\StructType\\GetVouchersPdf_UrlResponse',
            'GetVouchers_Str_Pdf_Url' => '\\StructType\\GetVouchers_Str_Pdf_Url',
            'GetVouchers_Str_Pdf_UrlResponse' => '\\StructType\\GetVouchers_Str_Pdf_UrlResponse',
            'GetVouchersPdf2A4' => '\\StructType\\GetVouchersPdf2A4',
            'GetVouchersPdf2A4Response' => '\\StructType\\GetVouchersPdf2A4Response',
            'GetVoucherPOD' => '\\StructType\\GetVoucherPOD',
            'GetVoucherPODResponse' => '\\StructType\\GetVoucherPODResponse',
            'GetVoucherPDFA6Margins' => '\\StructType\\GetVoucherPDFA6Margins',
            'GetVoucherPDFA6MarginsResponse' => '\\StructType\\GetVoucherPDFA6MarginsResponse',
            'GetVoucherPDFMargins' => '\\StructType\\GetVoucherPDFMargins',
            'GetVoucherPDFMarginsResponse' => '\\StructType\\GetVoucherPDFMarginsResponse',
            'GetVoucherPDFA4Double' => '\\StructType\\GetVoucherPDFA4Double',
            'GetVoucherPDFA4DoubleResponse' => '\\StructType\\GetVoucherPDFA4DoubleResponse',
        );
    }
}
