<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClsGetVoucherResp StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ClsGetVoucherResp
 * @subpackage Structs
 */
class ClsGetVoucherResp extends AbstractStructBase
{
    /**
     * The Document
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Document;
    /**
     * The Message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Message;
    /**
     * The Result
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Result;
    /**
     * The Voucher
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsVoucher
     */
    public $Voucher;
    /**
     * The VoucherTracking
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsVoucherTracking
     */
    public $VoucherTracking;
    /**
     * The Vouchers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfdecimal
     */
    public $Vouchers;
    /**
     * Constructor method for ClsGetVoucherResp
     * @uses ClsGetVoucherResp::setDocument()
     * @uses ClsGetVoucherResp::setMessage()
     * @uses ClsGetVoucherResp::setResult()
     * @uses ClsGetVoucherResp::setVoucher()
     * @uses ClsGetVoucherResp::setVoucherTracking()
     * @uses ClsGetVoucherResp::setVouchers()
     * @param string $document
     * @param string $message
     * @param bool $result
     * @param \StructType\ClsVoucher $voucher
     * @param \StructType\ClsVoucherTracking $voucherTracking
     * @param \ArrayType\ArrayOfdecimal $vouchers
     */
    public function __construct($document = null, $message = null, $result = null, \StructType\ClsVoucher $voucher = null, \StructType\ClsVoucherTracking $voucherTracking = null, \ArrayType\ArrayOfdecimal $vouchers = null)
    {
        $this
            ->setDocument($document)
            ->setMessage($message)
            ->setResult($result)
            ->setVoucher($voucher)
            ->setVoucherTracking($voucherTracking)
            ->setVouchers($vouchers);
    }
    /**
     * Get Document value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDocument()
    {
        return isset($this->Document) ? $this->Document : null;
    }
    /**
     * Set Document value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $document
     * @return \StructType\ClsGetVoucherResp
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        if (is_null($document) || (is_array($document) && empty($document))) {
            unset($this->Document);
        } else {
            $this->Document = $document;
        }
        return $this;
    }
    /**
     * Get Message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMessage()
    {
        return isset($this->Message) ? $this->Message : null;
    }
    /**
     * Set Message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $message
     * @return \StructType\ClsGetVoucherResp
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        if (is_null($message) || (is_array($message) && empty($message))) {
            unset($this->Message);
        } else {
            $this->Message = $message;
        }
        return $this;
    }
    /**
     * Get Result value
     * @return bool|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param bool $result
     * @return \StructType\ClsGetVoucherResp
     */
    public function setResult($result = null)
    {
        // validation for constraint: boolean
        if (!is_null($result) && !is_bool($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($result, true), gettype($result)), __LINE__);
        }
        $this->Result = $result;
        return $this;
    }
    /**
     * Get Voucher value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsVoucher|null
     */
    public function getVoucher()
    {
        return isset($this->Voucher) ? $this->Voucher : null;
    }
    /**
     * Set Voucher value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ClsVoucher $voucher
     * @return \StructType\ClsGetVoucherResp
     */
    public function setVoucher(\StructType\ClsVoucher $voucher = null)
    {
        if (is_null($voucher) || (is_array($voucher) && empty($voucher))) {
            unset($this->Voucher);
        } else {
            $this->Voucher = $voucher;
        }
        return $this;
    }
    /**
     * Get VoucherTracking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsVoucherTracking|null
     */
    public function getVoucherTracking()
    {
        return isset($this->VoucherTracking) ? $this->VoucherTracking : null;
    }
    /**
     * Set VoucherTracking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ClsVoucherTracking $voucherTracking
     * @return \StructType\ClsGetVoucherResp
     */
    public function setVoucherTracking(\StructType\ClsVoucherTracking $voucherTracking = null)
    {
        if (is_null($voucherTracking) || (is_array($voucherTracking) && empty($voucherTracking))) {
            unset($this->VoucherTracking);
        } else {
            $this->VoucherTracking = $voucherTracking;
        }
        return $this;
    }
    /**
     * Get Vouchers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfdecimal|null
     */
    public function getVouchers()
    {
        return isset($this->Vouchers) ? $this->Vouchers : null;
    }
    /**
     * Set Vouchers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfdecimal $vouchers
     * @return \StructType\ClsGetVoucherResp
     */
    public function setVouchers(\ArrayType\ArrayOfdecimal $vouchers = null)
    {
        if (is_null($vouchers) || (is_array($vouchers) && empty($vouchers))) {
            unset($this->Vouchers);
        } else {
            $this->Vouchers = $vouchers;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsGetVoucherResp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
