<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClsVoucherCheckpoint_Station2 StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ClsVoucherCheckpoint_Station2
 * @subpackage Structs
 */
class ClsVoucherCheckpoint_Station2 extends AbstractStructBase
{
    /**
     * The Checkpoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Checkpoint;
    /**
     * The CheckpointDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CheckpointDate;
    /**
     * The CheckpointStation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsStation
     */
    public $CheckpointStation;
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Code;
    /**
     * The ShipmentNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ShipmentNumber;
    /**
     * Constructor method for ClsVoucherCheckpoint_Station2
     * @uses ClsVoucherCheckpoint_Station2::setCheckpoint()
     * @uses ClsVoucherCheckpoint_Station2::setCheckpointDate()
     * @uses ClsVoucherCheckpoint_Station2::setCheckpointStation()
     * @uses ClsVoucherCheckpoint_Station2::setCode()
     * @uses ClsVoucherCheckpoint_Station2::setShipmentNumber()
     * @param string $checkpoint
     * @param string $checkpointDate
     * @param \StructType\ClsStation $checkpointStation
     * @param string $code
     * @param string $shipmentNumber
     */
    public function __construct($checkpoint = null, $checkpointDate = null, \StructType\ClsStation $checkpointStation = null, $code = null, $shipmentNumber = null)
    {
        $this
            ->setCheckpoint($checkpoint)
            ->setCheckpointDate($checkpointDate)
            ->setCheckpointStation($checkpointStation)
            ->setCode($code)
            ->setShipmentNumber($shipmentNumber);
    }
    /**
     * Get Checkpoint value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCheckpoint()
    {
        return isset($this->Checkpoint) ? $this->Checkpoint : null;
    }
    /**
     * Set Checkpoint value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $checkpoint
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public function setCheckpoint($checkpoint = null)
    {
        // validation for constraint: string
        if (!is_null($checkpoint) && !is_string($checkpoint)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkpoint, true), gettype($checkpoint)), __LINE__);
        }
        if (is_null($checkpoint) || (is_array($checkpoint) && empty($checkpoint))) {
            unset($this->Checkpoint);
        } else {
            $this->Checkpoint = $checkpoint;
        }
        return $this;
    }
    /**
     * Get CheckpointDate value
     * @return string|null
     */
    public function getCheckpointDate()
    {
        return $this->CheckpointDate;
    }
    /**
     * Set CheckpointDate value
     * @param string $checkpointDate
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public function setCheckpointDate($checkpointDate = null)
    {
        // validation for constraint: string
        if (!is_null($checkpointDate) && !is_string($checkpointDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkpointDate, true), gettype($checkpointDate)), __LINE__);
        }
        $this->CheckpointDate = $checkpointDate;
        return $this;
    }
    /**
     * Get CheckpointStation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsStation|null
     */
    public function getCheckpointStation()
    {
        return isset($this->CheckpointStation) ? $this->CheckpointStation : null;
    }
    /**
     * Set CheckpointStation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ClsStation $checkpointStation
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public function setCheckpointStation(\StructType\ClsStation $checkpointStation = null)
    {
        if (is_null($checkpointStation) || (is_array($checkpointStation) && empty($checkpointStation))) {
            unset($this->CheckpointStation);
        } else {
            $this->CheckpointStation = $checkpointStation;
        }
        return $this;
    }
    /**
     * Get Code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCode()
    {
        return isset($this->Code) ? $this->Code : null;
    }
    /**
     * Set Code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $code
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->Code);
        } else {
            $this->Code = $code;
        }
        return $this;
    }
    /**
     * Get ShipmentNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getShipmentNumber()
    {
        return isset($this->ShipmentNumber) ? $this->ShipmentNumber : null;
    }
    /**
     * Set ShipmentNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $shipmentNumber
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public function setShipmentNumber($shipmentNumber = null)
    {
        // validation for constraint: string
        if (!is_null($shipmentNumber) && !is_string($shipmentNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipmentNumber, true), gettype($shipmentNumber)), __LINE__);
        }
        if (is_null($shipmentNumber) || (is_array($shipmentNumber) && empty($shipmentNumber))) {
            unset($this->ShipmentNumber);
        } else {
            $this->ShipmentNumber = $shipmentNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsVoucherCheckpoint_Station2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
