<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DoWorkResponse StructType
 * @subpackage Structs
 */
class DoWorkResponse extends AbstractStructBase
{
    /**
     * The DoWorkResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DoWorkResult;
    /**
     * Constructor method for DoWorkResponse
     * @uses DoWorkResponse::setDoWorkResult()
     * @param string $doWorkResult
     */
    public function __construct($doWorkResult = null)
    {
        $this
            ->setDoWorkResult($doWorkResult);
    }
    /**
     * Get DoWorkResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDoWorkResult()
    {
        return isset($this->DoWorkResult) ? $this->DoWorkResult : null;
    }
    /**
     * Set DoWorkResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $doWorkResult
     * @return \StructType\DoWorkResponse
     */
    public function setDoWorkResult($doWorkResult = null)
    {
        // validation for constraint: string
        if (!is_null($doWorkResult) && !is_string($doWorkResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($doWorkResult, true), gettype($doWorkResult)), __LINE__);
        }
        if (is_null($doWorkResult) || (is_array($doWorkResult) && empty($doWorkResult))) {
            unset($this->DoWorkResult);
        } else {
            $this->DoWorkResult = $doWorkResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DoWorkResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
