<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVouchers_Str_Pdf_Url StructType
 * @subpackage Structs
 */
class GetVouchers_Str_Pdf_Url extends AbstractStructBase
{
    /**
     * The ListShipmentNumbers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ListShipmentNumbers;
    /**
     * The Margin_Left
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Margin_Left;
    /**
     * The Margin_Top
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Margin_Top;
    /**
     * The Credential
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsCredential
     */
    public $Credential;
    /**
     * Constructor method for GetVouchers_Str_Pdf_Url
     * @uses GetVouchers_Str_Pdf_Url::setListShipmentNumbers()
     * @uses GetVouchers_Str_Pdf_Url::setMargin_Left()
     * @uses GetVouchers_Str_Pdf_Url::setMargin_Top()
     * @uses GetVouchers_Str_Pdf_Url::setCredential()
     * @param string $listShipmentNumbers
     * @param int $margin_Left
     * @param int $margin_Top
     * @param \StructType\ClsCredential $credential
     */
    public function __construct($listShipmentNumbers = null, $margin_Left = null, $margin_Top = null, \StructType\ClsCredential $credential = null)
    {
        $this
            ->setListShipmentNumbers($listShipmentNumbers)
            ->setMargin_Left($margin_Left)
            ->setMargin_Top($margin_Top)
            ->setCredential($credential);
    }
    /**
     * Get ListShipmentNumbers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getListShipmentNumbers()
    {
        return isset($this->ListShipmentNumbers) ? $this->ListShipmentNumbers : null;
    }
    /**
     * Set ListShipmentNumbers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $listShipmentNumbers
     * @return \StructType\GetVouchers_Str_Pdf_Url
     */
    public function setListShipmentNumbers($listShipmentNumbers = null)
    {
        // validation for constraint: string
        if (!is_null($listShipmentNumbers) && !is_string($listShipmentNumbers)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($listShipmentNumbers, true), gettype($listShipmentNumbers)), __LINE__);
        }
        if (is_null($listShipmentNumbers) || (is_array($listShipmentNumbers) && empty($listShipmentNumbers))) {
            unset($this->ListShipmentNumbers);
        } else {
            $this->ListShipmentNumbers = $listShipmentNumbers;
        }
        return $this;
    }
    /**
     * Get Margin_Left value
     * @return int|null
     */
    public function getMargin_Left()
    {
        return $this->Margin_Left;
    }
    /**
     * Set Margin_Left value
     * @param int $margin_Left
     * @return \StructType\GetVouchers_Str_Pdf_Url
     */
    public function setMargin_Left($margin_Left = null)
    {
        // validation for constraint: int
        if (!is_null($margin_Left) && !(is_int($margin_Left) || ctype_digit($margin_Left))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($margin_Left, true), gettype($margin_Left)), __LINE__);
        }
        $this->Margin_Left = $margin_Left;
        return $this;
    }
    /**
     * Get Margin_Top value
     * @return int|null
     */
    public function getMargin_Top()
    {
        return $this->Margin_Top;
    }
    /**
     * Set Margin_Top value
     * @param int $margin_Top
     * @return \StructType\GetVouchers_Str_Pdf_Url
     */
    public function setMargin_Top($margin_Top = null)
    {
        // validation for constraint: int
        if (!is_null($margin_Top) && !(is_int($margin_Top) || ctype_digit($margin_Top))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($margin_Top, true), gettype($margin_Top)), __LINE__);
        }
        $this->Margin_Top = $margin_Top;
        return $this;
    }
    /**
     * Get Credential value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsCredential|null
     */
    public function getCredential()
    {
        return isset($this->Credential) ? $this->Credential : null;
    }
    /**
     * Set Credential value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ClsCredential $credential
     * @return \StructType\GetVouchers_Str_Pdf_Url
     */
    public function setCredential(\StructType\ClsCredential $credential = null)
    {
        if (is_null($credential) || (is_array($credential) && empty($credential))) {
            unset($this->Credential);
        } else {
            $this->Credential = $credential;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVouchers_Str_Pdf_Url
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
